﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=4.7
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Dim System As JavaObject
	Dim NewObjArray() As Object
	Dim CloneMap As Map
	Type CloneType(Module As Object,CloneFunction As String)
End Sub

Private Sub GetPackageName As String
	#if B4a
		Return Application.PackageName
	#end if
	#if B4j
		Dim MEJO As JavaObject = Me
		Dim MS As String = MEJO.RunMethod("toString",Null)
		Return MS.SubString2(MS.IndexOf(" ")+1,MS.LastIndexOf("."))
	#end if
End Sub

Private Sub ThrowIllegalArgumentException(Msg As String)
	Dim MEJO As JavaObject
	MEJO.InitializeStatic(GetPackageName & ".cloneobject")
	MEJO.RunMethod("ThrowIllegalArgumentException",Array(Msg))
End Sub

'Register a type or class Clone Function
'Module - The module in which you have created the Clone function
'Example = an example of the type or class
'Clone function = The function to call in the module
Public Sub RegisterCloneFunction(Module As Object,Example As Object,CloneFunction As String)
	If Not(CloneMap.IsInitialized) Then CloneMap.Initialize
	Dim CT As CloneType
	CT.Initialize
	CT.Module = Module
	CT.CloneFunction = CloneFunction
	CloneMap.Put(GetType(Example),CT)
End Sub
'UnRegister a type or class Clone Function 
'Example = an example of the type or class
Public Sub UnRegisterCloneFunction(Example As Object)
	If Not(CloneMap.IsInitialized) Then Return
	CloneMap.Remove(GetType(Example))
End Sub

'Clear all currently stored clone functions
Public Sub ClearAllCloneFunctions
	If CloneMap.IsInitialized Then CloneMap.Clear
End Sub

'Clone an object.  If any of the collections contained in the object include a Class ot a Type you need to create and register a Clone Function for it.
Public Sub Clone (Obj As Object) As Object
	Return CloneNext(Obj,0)
End Sub

Private Sub CloneNext(Obj As Object,Level As Int) As Object
	Level = Level + 1
	If Obj = Null Then 
		Return Obj
	End If
	Dim ThisType As String = GetType(Obj)
'	Log("Cloning "& ThisType & " : " & " Level " & Level)
	If ThisType.StartsWith("java.lang") Then
		Dim JO As JavaObject
		JO.InitializeNewInstance(ThisType,Array(Obj))
		Return JO
	End If
	
	If ThisType = "java.util.ArrayList"  Or ThisType = "java.util.Arrays$ArrayList" Or ThisType = "anywheresoftware.b4a.objects.collections.List" Then
		Dim NewList As List
		NewList.Initialize
		If ThisType = "java.util.ArrayList"  Or ThisType = "java.util.Arrays$ArrayList" Then
			Dim L1 As List = Obj
		Else
			Dim L1 As List
			Dim L2 As JavaObject = Obj
			L1 = L2.RunMethod("getObject",Null)
		End If
		
		For i = 0 To L1.Size -1
			NewList.Add(CloneNext(L1.Get(i),Level))
		Next
		Return NewList
	End If
	
	If ThisType = "anywheresoftware.b4a.objects.collections.Map$MyMap" Then
		Dim NewMap As Map
		NewMap.Initialize
		
		Dim M1 As Map = Obj
	
		For Each Key As Object In M1.Keys
			NewMap.Put(Key,CloneNext(M1.Get(Key),Level))
		Next
		Return NewMap
	End If
	
	If ThisType.StartsWith("[") Then
		If System.IsInitialized = False Then System.InitializeStatic("java.lang.System")
'		Log("TT1,1" & ThisType.SubString2(1,2))
		Select ThisType.SubString2(1,2)
			Case "I":
				Dim A() As Int = Obj
				Dim NewIntArray(A.length) As Int
				System.RunMethod("arraycopy",Array(A,0,NewIntArray,0,A.Length))
'				Log(NewIntArray.Length)
				Return NewIntArray
			Case "D"
				Dim D() As Double = Obj
				Dim NewDArray(D.length) As Double
				System.RunMethod("arraycopy",Array(D,0,NewDArray,0,D.Length))
				Return NewDArray
			Case "F"
				Dim F() As Float = Obj
				Dim NewFArray(F.length) As Float
				System.RunMethod("arraycopy",Array(F,0,NewFArray,0,F.Length))
'				Log(NewFArray.Length)
				Return NewFArray
			Case "C"
				Dim C() As Char = Obj
				Dim NewCArray(C.length) As Char
				System.RunMethod("arraycopy",Array(C,0,NewCArray,0,C.Length))
'				Log(NewCArray.Length)
				Return NewCArray
			Case "S"
				Dim S() As Short = Obj
				Dim NewSArray(S.length) As Short
				System.RunMethod("arraycopy",Array(S,0,NewSArray,0,S.Length))
'				Log(NewSArray.Length)
				Return NewSArray
			Case "B"
				Dim B() As Byte = Obj
				Dim NewBArray(B.length) As Byte
				System.RunMethod("arraycopy",Array(B,0,NewBArray,0,B.Length))
'				Log(NewBArray.Length)
				Return NewBArray
			Case "Z"
				Dim Z() As Boolean = Obj
				Dim NewZArray(Z.length) As Boolean
				System.RunMethod("arraycopy",Array(Z,0,NewZArray,0,Z.Length))
'				Log(NewZArray.Length)
				Return NewZArray
			Case "L"
				If ThisType = "[Ljava.lang.String;" Then
					Dim L() As String = Obj
					Dim NewLArray(L.length) As String
					System.RunMethod("arraycopy",Array(L,0,NewLArray,0,L.Length))
					Return NewLArray
				End If
				If ThisType = "[Ljava.lang.Object;" Then
					Dim O() As Object = Obj
					Dim NewOArray(O.length) As String
					System.RunMethod("arraycopy",Array(O,0,NewOArray,0,O.Length))
'					Log(NewOArray.Length)
					Return NewOArray
				End If
				'Types / Classes
				Dim MEJO As JavaObject
				MEJO.InitializeStatic(GetPackageName & ".cloneobject")
				Dim ObjArr() As Object = MEJO.RunMethod("convertObject",Array(Obj))
				
				'Create a new Array of the correct type
				Dim RA As JavaObject
				RA.InitializeStatic("java.lang.reflect.Array")
				Dim ClassClass As JavaObject
				ClassClass.InitializeStatic("java.lang.Class")
				Dim ClassName As String = ThisType.SubString2(2,ThisType.Length -1)
				Dim NewObjArray() As Object = RA.RunMethod("newInstance",Array(ClassClass.RunMethod("forName",Array(ClassName)),ObjArr.Length))
				'Clone each array item
				For i = 0 To ObjArr.Length - 1
					NewObjArray(i) = CloneNext(ObjArr(i),Level)
				Next
				
				Return NewObjArray
		End Select
	End If
	
	'Types / Classes
	If CloneMap.IsInitialized Then
		Dim CT As CloneType = CloneMap.Get(ThisType)
		If CT <> Null Then
			If SubExists(CT.Module,CT.CloneFunction) Then
				Return CallSub2(CT.Module,CT.CloneFunction,Obj)
			End If
		End If
	End If
	Dim Msg As String = $"CloneObject Error - Failed to recognize type ${ThisType}. If it's a Type or Class, did you forget to register a clone function? "$
	ThrowIllegalArgumentException(Msg)
	Log("*****")
	Log(Msg)
	Log("*****")
	Return Null
End Sub

#if java

public static Object[] convertObject(Object Obj){
	return (Object[]) Obj;
}

public static void ThrowIllegalArgumentException(String msg){
	throw new IllegalArgumentException(msg);
}
#end if